/**
 * Functions dealing with DARIAH-DE Storage upload, download, sharing, unsharing, and deleting.
 *
 * FIXME: PDP tokens!
 *
 * TODO: jquery object
 */

/*
 * Create new file, get unique storage file ID.
 */
function postToDariahStorage(postdata) {
    checkStorageToken();
	// Re-set dsid.
	dsid = "";
	$.ajax({
		url: storageURL,
		type: 'POST',
		contentType: 'text/csv',
		data: postdata,
		success: function(data, status, xhr) {
			//console.log('loc: ' + xhr.getResponseHeader('Location'));
			var location = xhr.getResponseHeader('Location');
			dsid = location.substring(location.lastIndexOf('/') + 1);
			document.location.hash='id='+dsid;
            url = storageURL + dsid;
            $('#dataLoc input').val(dsid);
            $('#dataLoc button').data('clipboard-text', url);
            newSheetAlert(url);
		},
		error: function (data, text, error) {
            var title = 'Error creating new file in DARIAH-DE OwnStorage!';
            var message = '<p>No new dataset could be created in the DARIAH-DE OwnStorage! '
                + 'Error message: <strong>' + error + '</strong></p>';
            newAlert('error', title,  message);
		}
		/*complete: function(xhr, status) {
			console.log(status);
			console.log('loc: ' + xhr.getResponseHeader('Location'));
			console.log('hdrs: ' + xhr.getAllResponseHeaders());
		}*/
	});
}

/**
 *Load file from DARIAH-DE storage using storage ID.
 */
function loadFromDariahStorage(id) {
	$.get(storageURL + id)
		.success(function(data) {
			csvToTable(data);
		})
		.error(function() {
            var title = 'Error loading dataset from the DARIAH-DE OwnStorage!';
            var message = '<p>The dataset with URL ' + storageURL + id + ' could not be loaded from the '
            + 'DARIAH-DE OwnStorage! Error message: <strong>' + error + '</strong></p>';
            newAlert('error', title,  message);
		});
}

/*
 * Update a dataset (file) using ID and post data.
 */
function updateDariahStorage(id, postdata) {
	$.ajax({
		url: storageURL+id,
		type: 'PUT',
		contentType: 'text/csv',
		data: postdata,
		complete: function( response ) {
			console.log(response);
		}
	});
}

/**
 * Share a dataset using the publish() method of the DARIAH-DE PDP using DARIAH-DE OwnStorage.
 */
function shareDataset() {
    $('#shareButton').hide();
    $('#unshareButton').show();
}

/**
 * Unshare a dataset (again)  using the unpublish() method of the DARIAH-DE PDP using DARIAH-DE OwnStorage.
 */
function unshareDataset() {
    $('#unshareButton').hide();
    $('#shareButton').show();
}

/**
 * Delete a dataset from the DARIAH-DE OwnStorage.
 */
function deleteDataset() {
}

/**
 * Check if token is existing and valid(?).
 */
function checkStorageToken() {
    var tok = sessionStorage.getItem('tok');

    if (window.location.hash) {
        window.location = window.location.origin
                + window.location.pathname + "?view=token&"
                + window.location.hash.substr(1);
    } else {
        window.location = pdpURL + window.location.origin + window.location.pathname;
    }

    return tok;
}
